Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/include/VisibilityEnvironment.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/include/VisibilityEnvironment.h	(revision 938)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/include/VisibilityEnvironment.h	(revision 1004)
@@ -40,5 +40,5 @@
 
 protected:
-	GtpVisibilityPreprocessor::Environment *mEnvironment;
+	//GtpVisibilityPreprocessor::Environment *Environment::GetSingleton();
 };
 } // namespace GtpVisibility
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/VisibilityEnvironment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/VisibilityEnvironment.cpp	(revision 971)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/VisibilityEnvironment.cpp	(revision 1004)
@@ -12,10 +12,11 @@
 	GtpVisibilityPreprocessor::Debug.open("debug.log");
 	// load environment
-	mEnvironment = new GtpVisibilityPreprocessor::Environment();	 
+	//Environment::GetSingleton() = new GtpVisibilityPreprocessor::Environment::GetSingleton();	 
 }
 //-----------------------------------------------------------------------
 VisibilityEnvironment::~VisibilityEnvironment()
 {
-	DEL_PTR(mEnvironment);	 
+	//DEL_PTR(Environment::GetSingleton());
+	GtpVisibilityPreprocessor::Environment::DelSingleton();
 }
 //-----------------------------------------------------------------------
@@ -23,5 +24,5 @@
 {		
 	//-- parse environment
-	return mEnvironment->ReadEnvFile(filename.c_str());
+	return GtpVisibilityPreprocessor::Environment::GetSingleton()->ReadEnvFile(filename.c_str());
 }
 //-----------------------------------------------------------------------
@@ -29,5 +30,5 @@
 {
 	char str[200];
-	mEnvironment->GetStringValue("Scene.filename", str);
+	GtpVisibilityPreprocessor::Environment::GetSingleton()->GetStringValue("Scene.filename", str);
 	return str;
 }
@@ -36,5 +37,6 @@
 {
 	char str[200];
-	mEnvironment->GetStringValue("ViewCells.filename", str);
+	GtpVisibilityPreprocessor::Environment::GetSingleton()->GetStringValue("ViewCells.filename", str);
+	
 	return str;
 }
@@ -42,5 +44,5 @@
 GtpVisibilityPreprocessor::Environment *VisibilityEnvironment::GetPreprocessorEnvironment()
 {
-	return mEnvironment;
+	return GtpVisibilityPreprocessor::Environment::GetSingleton();
 }
 } // namespace GtpVisibility
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 975)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 1004)
@@ -1029,11 +1029,7 @@
 	OgreBoundingBoxConverter bconverter(this);
 
-	
-	GtpVisibilityPreprocessor::Environment *env = 
-		mVisibilityManager->GetVisibilityEnvironment()->GetPreprocessorEnvironment();
-
 	// load the view cells assigning the found objects to the pvss
 	mViewCellsManager = 
-		GtpVisibilityPreprocessor::ViewCellsManager::LoadViewCells(filename, &mObjects, env, false, &bconverter);
+		GtpVisibilityPreprocessor::ViewCellsManager::LoadViewCells(filename, &mObjects, false, &bconverter);
 
 	return (mViewCellsManager != NULL);
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj	(revision 1004)
@@ -176,6 +176,5 @@
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
-"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp&#xA;"
 						Outputs="$(InputDir)moc_$(InputName).cpp"/>
 				</FileConfiguration>
@@ -308,6 +307,5 @@
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
-"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp&#xA;"
 						Outputs="$(InputDir)moc_$(InputName).cpp"/>
 				</FileConfiguration>
@@ -323,6 +321,5 @@
 						Name="VCCustomBuildTool"
 						Description="Performing moc on $(InputName).h"
-						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp
-"
+						CommandLine="%qtdir%\bin\moc.exe $(InputDir)$(InputName).h -o $(InputDir)moc_$(InputName).cpp&#xA;"
 						Outputs="$(InputDir)moc_$(InputName).cpp"/>
 				</FileConfiguration>
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.cpp	(revision 882)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.cpp	(revision 1004)
@@ -407,33 +407,33 @@
 VspKdTree::VspKdTree(): mOnlyDrivingAxis(false)
 {
-	environment->GetIntValue("VspKdTree.Termination.maxDepth", mTermMaxDepth);
-	environment->GetIntValue("VspKdTree.Termination.minPvs", mTermMinPvs);
-	environment->GetIntValue("VspKdTree.Termination.minRays", mTermMinRays);
-	environment->GetFloatValue("VspKdTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	environment->GetFloatValue("VspKdTree.Termination.maxCostRatio", mTermMaxCostRatio);
-	environment->GetFloatValue("VspKdTree.Termination.minSize", mTermMinSize);
-
-	environment->GetIntValue("VspKdTree.Termination.missTolerance", mTermMissTolerance);
+	Environment::GetSingleton()->GetIntValue("VspKdTree.Termination.maxDepth", mTermMaxDepth);
+	Environment::GetSingleton()->GetIntValue("VspKdTree.Termination.minPvs", mTermMinPvs);
+	Environment::GetSingleton()->GetIntValue("VspKdTree.Termination.minRays", mTermMinRays);
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.Termination.maxRayContribution", mTermMaxRayContribution);
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.Termination.minSize", mTermMinSize);
+
+	Environment::GetSingleton()->GetIntValue("VspKdTree.Termination.missTolerance", mTermMissTolerance);
 
 	mTermMinSize = sqr(mTermMinSize);
 
-	environment->GetFloatValue("VspKdTree.epsilon", mEpsilon);
-	environment->GetFloatValue("VspKdTree.ct_div_ci", mCtDivCi);
-
-	environment->GetFloatValue("VspKdTree.maxTotalMemory", mMaxTotalMemory);
-	environment->GetFloatValue("VspKdTree.maxStaticMemory", mMaxStaticMemory);
-
-	environment->GetIntValue("VspKdTree.accessTimeThreshold", mAccessTimeThreshold);
-	environment->GetIntValue("VspKdTree.minCollapseDepth", mMinCollapseDepth);
-
-	//environment->GetIntValue("ViewCells.maxViewCells", mMaxViewCells);
-
-	environment->GetIntValue("VspKdTree.PostProcess.minViewCells", mMergeMinViewCells);
-	environment->GetFloatValue("VspKdTree.PostProcess.maxCostRatio", mMergeMaxCostRatio);
-	environment->GetIntValue("VspKdTree.PostProcess.maxPvsSize",
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.epsilon", mEpsilon);
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.ct_div_ci", mCtDivCi);
+
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.maxTotalMemory", mMaxTotalMemory);
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.maxStaticMemory", mMaxStaticMemory);
+
+	Environment::GetSingleton()->GetIntValue("VspKdTree.accessTimeThreshold", mAccessTimeThreshold);
+	Environment::GetSingleton()->GetIntValue("VspKdTree.minCollapseDepth", mMinCollapseDepth);
+
+	//Environment::GetSingleton()->GetIntValue("ViewCells.maxViewCells", mMaxViewCells);
+
+	Environment::GetSingleton()->GetIntValue("VspKdTree.PostProcess.minViewCells", mMergeMinViewCells);
+	Environment::GetSingleton()->GetFloatValue("VspKdTree.PostProcess.maxCostRatio", mMergeMaxCostRatio);
+	Environment::GetSingleton()->GetIntValue("VspKdTree.PostProcess.maxPvsSize",
 							 VspKdMergeCandidate::sMaxPvsSize);
 
-	environment->GetBoolValue("VspKdTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
-	environment->GetIntValue("VspKdTree.Termination.maxViewCells", mMaxViewCells);
+	Environment::GetSingleton()->GetBoolValue("VspKdTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
+	Environment::GetSingleton()->GetIntValue("VspKdTree.Termination.maxViewCells", mMaxViewCells);
 
 	//-- output
@@ -450,5 +450,5 @@
 	//-- split type
 	char sname[128];
-	environment->GetStringValue("VspKdTree.splitType", sname);
+	Environment::GetSingleton()->GetStringValue("VspKdTree.splitType", sname);
 	string name(sname);
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.cpp	(revision 1004)
@@ -751,5 +751,5 @@
 				VssRay *ray;
 				
-				const indices[][2] = {{0,0}, {0,1}, {1,1}, {1,0}}; 
+				const int indices[][2] = {{0,0}, {0,1}, {1,1}, {1,0}}; 
 				MeshInstance dummy(mesh);
 				for (int i=0; i < 4; i++) 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 1004)
@@ -175,5 +175,5 @@
 			Vector3 transl;
 							
-			if (sscanf(ptr, "%f %f %f %f", &transl.x, &transl.y, &transl.z) == 3)
+			if (sscanf(ptr, "%f %f %f", &transl.x, &transl.y, &transl.z) == 3)
 			{
 				translm = new Matrix4x4(TranslationMatrix(transl));
@@ -184,5 +184,5 @@
 			Vector3 scale;
 
-			if (sscanf(ptr, "%f %f %f %f", &scale.x, &scale.y, &scale.z) == 3)
+			if (sscanf(ptr, "%f %f %f", &scale.x, &scale.y, &scale.z) == 3)
 			{
 				scalem = new Matrix4x4(ScaleMatrix(scale.x, scale.y, scale.z));
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.h	(revision 938)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.h	(revision 1004)
@@ -21,6 +21,5 @@
 				 ViewCellsManager **viewCells,
 				 ObjectContainer *objectsm,
-				 BoundingBoxConverter *bconverter,
-				 Environment *env);
+				 BoundingBoxConverter *bconverter);
 };
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 1004)
@@ -55,5 +55,5 @@
 
 
-VspBspTree::VspBspTree(Environment *env):
+VspBspTree::VspBspTree():
 mRoot(NULL),
 mUseAreaForPvs(false),
@@ -67,70 +67,70 @@
 {
 	bool randomize = false;
-	env->GetBoolValue("VspBspTree.Construction.randomize", randomize);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.Construction.randomize", randomize);
 	if (randomize)
 		Randomize(); // initialise random generator for heuristics
 
 	//-- termination criteria for autopartition
-	env->GetIntValue("VspBspTree.Termination.maxDepth", mTermMaxDepth);
-	env->GetIntValue("VspBspTree.Termination.minPvs", mTermMinPvs);
-	env->GetIntValue("VspBspTree.Termination.minRays", mTermMinRays);
-	env->GetFloatValue("VspBspTree.Termination.minProbability", mTermMinProbability);
-	env->GetFloatValue("VspBspTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	env->GetFloatValue("VspBspTree.Termination.minAccRayLenght", mTermMinAccRayLength);
-	env->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
-	env->GetIntValue("VspBspTree.Termination.missTolerance", mTermMissTolerance);
-	env->GetIntValue("VspBspTree.Termination.maxViewCells", mMaxViewCells);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.maxDepth", mTermMaxDepth);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.minPvs", mTermMinPvs);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.minRays", mTermMinRays);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.minProbability", mTermMinProbability);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.maxRayContribution", mTermMaxRayContribution);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.minAccRayLenght", mTermMinAccRayLength);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.missTolerance", mTermMissTolerance);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.maxViewCells", mMaxViewCells);
 
 	//-- max cost ratio for early tree termination
-	env->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
-
-	env->GetFloatValue("VspBspTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
-	env->GetIntValue("VspBspTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.maxCostRatio", mTermMaxCostRatio);
+
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
 
 	// HACK//mTermMinPolygons = 25;
 
 	//-- factors for bsp tree split plane heuristics
-	env->GetFloatValue("VspBspTree.Factor.pvs", mPvsFactor);
-	env->GetFloatValue("VspBspTree.Termination.ct_div_ci", mCtDivCi);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Factor.pvs", mPvsFactor);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.ct_div_ci", mCtDivCi);
 
 
 	//-- partition criteria
-	env->GetIntValue("VspBspTree.maxPolyCandidates", mMaxPolyCandidates);
-	env->GetIntValue("VspBspTree.maxRayCandidates", mMaxRayCandidates);
-	env->GetIntValue("VspBspTree.splitPlaneStrategy", mSplitPlaneStrategy);
-
-	env->GetFloatValue("VspBspTree.Construction.epsilon", mEpsilon);
-	env->GetIntValue("VspBspTree.maxTests", mMaxTests);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.maxPolyCandidates", mMaxPolyCandidates);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.maxRayCandidates", mMaxRayCandidates);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.splitPlaneStrategy", mSplitPlaneStrategy);
+
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Construction.epsilon", mEpsilon);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.maxTests", mMaxTests);
 
 	// if only the driving axis is used for axis aligned split
-	env->GetBoolValue("VspBspTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
 	
 	//-- termination criteria for axis aligned split
-	env->GetFloatValue("VspBspTree.Termination.AxisAligned.maxRayContribution", 
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Termination.AxisAligned.maxRayContribution", 
 								mTermMaxRayContriForAxisAligned);
-	env->GetIntValue("VspBspTree.Termination.AxisAligned.minRays",
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Termination.AxisAligned.minRays",
 							 mTermMinRaysForAxisAligned);
 
-	//env->GetFloatValue("VspBspTree.maxTotalMemory", mMaxTotalMemory);
-	env->GetFloatValue("VspBspTree.maxStaticMemory", mMaxMemory);
-
-	env->GetFloatValue("VspBspTree.Construction.renderCostWeight", mRenderCostWeight);
-	env->GetBoolValue("VspBspTree.usePolygonSplitIfAvailable", mUsePolygonSplitIfAvailable);
-
-	env->GetBoolValue("VspBspTree.useCostHeuristics", mUseCostHeuristics);
-	env->GetBoolValue("VspBspTree.useSplitCostQueue", mUseSplitCostQueue);
-	env->GetBoolValue("VspBspTree.simulateOctree", mCirculatingAxis);
-	env->GetBoolValue("VspBspTree.useRandomAxis", mUseRandomAxis);
-	env->GetIntValue("VspBspTree.nodePriorityQueueType", mNodePriorityQueueType);
-
-	env->GetBoolValue("ViewCells.PostProcess.emptyViewCellsMerge", mEmptyViewCellsMergeAllowed);
+	//Environment::GetSingleton()->GetFloatValue("VspBspTree.maxTotalMemory", mMaxTotalMemory);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.maxStaticMemory", mMaxMemory);
+
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Construction.renderCostWeight", mRenderCostWeight);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.usePolygonSplitIfAvailable", mUsePolygonSplitIfAvailable);
+
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.useCostHeuristics", mUseCostHeuristics);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.useSplitCostQueue", mUseSplitCostQueue);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.simulateOctree", mCirculatingAxis);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.useRandomAxis", mUseRandomAxis);
+	Environment::GetSingleton()->GetIntValue("VspBspTree.nodePriorityQueueType", mNodePriorityQueueType);
+
+	Environment::GetSingleton()->GetBoolValue("ViewCells.PostProcess.emptyViewCellsMerge", mEmptyViewCellsMergeAllowed);
 	
 	char subdivisionStatsLog[100];
-	env->GetStringValue("VspBspTree.subdivisionStats", subdivisionStatsLog);
+	Environment::GetSingleton()->GetStringValue("VspBspTree.subdivisionStats", subdivisionStatsLog);
 	mSubdivisionStats.open(subdivisionStatsLog);
 
-	env->GetFloatValue("VspBspTree.Construction.minBand", mMinBand);
-	env->GetFloatValue("VspBspTree.Construction.maxBand", mMaxBand);
-	env->GetBoolValue("VspBspTree.Construction.useDrivingAxisForMaxCost", mUseDrivingAxisForMaxCost);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Construction.minBand", mMinBand);
+	Environment::GetSingleton()->GetFloatValue("VspBspTree.Construction.maxBand", mMaxBand);
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.Construction.useDrivingAxisForMaxCost", mUseDrivingAxisForMaxCost);
 
 	//-- debug output
@@ -198,5 +198,5 @@
 	Debug << endl;
 }
-
+/*
 VspBspTree::VspBspTree():
 mRoot(NULL),
@@ -211,5 +211,5 @@
 mEpsilon(1e-6f)
 {
-}
+}*/
 
 BspViewCell *VspBspTree::GetOutOfBoundsCell()
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1004)
@@ -33,5 +33,5 @@
 class MergeCandidate;
 class BoundingBoxConverter;
-class Environment;
+
 
 struct BspRay;
@@ -72,7 +72,7 @@
 	enum {PER_OBJECT, PER_TRIANGLE};
 
-	/** default constructor taking an environment file.
-	*/
-	ViewCellsManager(Environment *env);
+	/** Default constructor.
+	*/
+	ViewCellsManager();
 
 	virtual ~ViewCellsManager();
@@ -409,5 +409,5 @@
 		of the hierarchy.
 	*/
-	inline void SetScalarPvsSize(ViewCell *vc, const int pvsSize) const;
+	void SetScalarPvsSize(ViewCell *vc, const int pvsSize) const;
 
 
@@ -433,5 +433,4 @@
 		@param filename the filename of the view cells
 		@param objects the scene objects
-		@param env an environment file containing more parameters
 		@param finalizeViewCells if the view cells should be post processed, i.e.
 			a mesh is created representing the geometry
@@ -443,5 +442,4 @@
 	static ViewCellsManager *LoadViewCells(const string &filename, 
 										   ObjectContainer *objects, 
-										   Environment *env,
 										   const bool finalizeViewCells,
 										   BoundingBoxConverter *bconverter = NULL);
@@ -571,5 +569,5 @@
 	bool mExportBboxesForPvs;
 		
-	Environment *environment;
+	//Environment *environment;
 	Plane3 mClipPlane;
 
@@ -652,7 +650,4 @@
 	/// if pvs should be exported with view cells
 	bool mExportPvs;
-
-	/// the pointer to the environment
-	Environment *mEnvironment;
 };
 
@@ -668,5 +663,5 @@
 		used to construct the bsp tree.
 	*/
-	BspViewCellsManager(BspTree *tree, Environment *env);
+	BspViewCellsManager(BspTree *tree);
 
 	~BspViewCellsManager();
@@ -757,5 +752,5 @@
 public:
 
-	KdViewCellsManager(KdTree *tree, Environment *env);
+	KdViewCellsManager(KdTree *tree);
 
 	int ConstructSubdivision(const ObjectContainer &objects, 
@@ -826,5 +821,5 @@
 public:
 
-	VspKdViewCellsManager(VspKdTree *vspKdTree, Environment *env);
+	VspKdViewCellsManager(VspKdTree *vspKdTree);
 
 	int ConstructSubdivision(const ObjectContainer &objects, 
@@ -892,5 +887,5 @@
 public:
 
-	VspBspViewCellsManager(VspBspTree *tree, Environment *env);
+	VspBspViewCellsManager(VspBspTree *tree);
 	~VspBspViewCellsManager();
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1004)
@@ -26,5 +26,23 @@
 
 
-Environment *environment = NULL;
+//Environment *environment = NULL;
+Environment *Environment::sEnvironment = NULL;
+
+
+Environment *Environment::GetSingleton()
+{
+	if (!sEnvironment)
+	{
+		sEnvironment = new Environment();
+	}
+
+	return sEnvironment;
+}
+
+void Environment::DelSingleton()
+{
+	DEL_PTR(sEnvironment);
+}
+
 
 Environment::~Environment()
@@ -2219,5 +2237,5 @@
   if (!GetParam(' ', 0, filename)) {
     // user didn't specified environment file explicitly, so
-    strcpy(filename, "default.env");
+    strcpy(filename, "default.Environment::GetSingleton()");
   }
   
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.cpp	(revision 1004)
@@ -227,45 +227,45 @@
 
 	//-- termination criteria for autopartition
-	environment->GetIntValue("BspTree.Termination.maxDepth", mTermMaxDepth);
-	environment->GetIntValue("BspTree.Termination.minPvs", mTermMinPvs);
-	environment->GetIntValue("BspTree.Termination.minPolygons", mTermMinPolys);
-	environment->GetIntValue("BspTree.Termination.minRays", mTermMinRays);
-	environment->GetFloatValue("BspTree.Termination.minProbability", mTermMinProbability);	
-	environment->GetFloatValue("BspTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	environment->GetFloatValue("BspTree.Termination.minAccRayLenght", mTermMinAccRayLength);
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.maxDepth", mTermMaxDepth);
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.minPvs", mTermMinPvs);
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.minPolygons", mTermMinPolys);
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.minRays", mTermMinRays);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Termination.minProbability", mTermMinProbability);	
+	Environment::GetSingleton()->GetFloatValue("BspTree.Termination.maxRayContribution", mTermMaxRayContribution);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Termination.minAccRayLenght", mTermMinAccRayLength);
 
 	//-- factors for bsp tree split plane heuristics
-	environment->GetFloatValue("BspTree.Factor.verticalSplits", mVerticalSplitsFactor);
-	environment->GetFloatValue("BspTree.Factor.largestPolyArea", mLargestPolyAreaFactor);
-	environment->GetFloatValue("BspTree.Factor.blockedRays", mBlockedRaysFactor);
-	environment->GetFloatValue("BspTree.Factor.leastRaySplits", mLeastRaySplitsFactor);
-	environment->GetFloatValue("BspTree.Factor.balancedRays", mBalancedRaysFactor);
-	environment->GetFloatValue("BspTree.Factor.pvs", mPvsFactor);
-	environment->GetFloatValue("BspTree.Factor.leastSplits" , mLeastSplitsFactor);
-	environment->GetFloatValue("BspTree.Factor.balancedPolys", mBalancedPolysFactor);
-	environment->GetFloatValue("BspTree.Factor.balancedViewCells", mBalancedViewCellsFactor);
-	environment->GetFloatValue("BspTree.Termination.ct_div_ci", mCtDivCi);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.verticalSplits", mVerticalSplitsFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.largestPolyArea", mLargestPolyAreaFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.blockedRays", mBlockedRaysFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.leastRaySplits", mLeastRaySplitsFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.balancedRays", mBalancedRaysFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.pvs", mPvsFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.leastSplits" , mLeastSplitsFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.balancedPolys", mBalancedPolysFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Factor.balancedViewCells", mBalancedViewCellsFactor);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Termination.ct_div_ci", mCtDivCi);
 
 	//-- termination criteria for axis aligned split
-	environment->GetFloatValue("BspTree.Termination.AxisAligned.ct_div_ci", mAxisAlignedCtDivCi);
-	environment->GetFloatValue("BspTree.Termination.maxCostRatio", mMaxCostRatio);
-	environment->GetIntValue("BspTree.Termination.AxisAligned.minPolys", 
+	Environment::GetSingleton()->GetFloatValue("BspTree.Termination.AxisAligned.ct_div_ci", mAxisAlignedCtDivCi);
+	Environment::GetSingleton()->GetFloatValue("BspTree.Termination.maxCostRatio", mMaxCostRatio);
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.AxisAligned.minPolys", 
 							 mTermMinPolysForAxisAligned);
-	environment->GetIntValue("BspTree.Termination.AxisAligned.minRays", 
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.AxisAligned.minRays", 
 							 mTermMinRaysForAxisAligned);
-	environment->GetIntValue("BspTree.Termination.AxisAligned.minObjects", 
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.AxisAligned.minObjects", 
 							 mTermMinObjectsForAxisAligned);
 	//-- partition criteria
-	environment->GetIntValue("BspTree.maxPolyCandidates", mMaxPolyCandidates);
-	environment->GetIntValue("BspTree.maxRayCandidates", mMaxRayCandidates);
-	environment->GetIntValue("BspTree.splitPlaneStrategy", mSplitPlaneStrategy);
-	environment->GetFloatValue("BspTree.AxisAligned.splitBorder", mSplitBorder);
-	environment->GetIntValue("BspTree.maxTests", mMaxTests);
-	environment->GetIntValue("BspTree.Termination.maxViewCells", mMaxViewCells);
-
-	environment->GetFloatValue("BspTree.Construction.epsilon", mEpsilon);
+	Environment::GetSingleton()->GetIntValue("BspTree.maxPolyCandidates", mMaxPolyCandidates);
+	Environment::GetSingleton()->GetIntValue("BspTree.maxRayCandidates", mMaxRayCandidates);
+	Environment::GetSingleton()->GetIntValue("BspTree.splitPlaneStrategy", mSplitPlaneStrategy);
+	Environment::GetSingleton()->GetFloatValue("BspTree.AxisAligned.splitBorder", mSplitBorder);
+	Environment::GetSingleton()->GetIntValue("BspTree.maxTests", mMaxTests);
+	Environment::GetSingleton()->GetIntValue("BspTree.Termination.maxViewCells", mMaxViewCells);
+
+	Environment::GetSingleton()->GetFloatValue("BspTree.Construction.epsilon", mEpsilon);
 
 	char subdivisionStatsLog[100];
-	environment->GetStringValue("BspTree.subdivisionStats", subdivisionStatsLog);
+	Environment::GetSingleton()->GetStringValue("BspTree.subdivisionStats", subdivisionStatsLog);
 	mSubdivisionStats.open(subdivisionStatsLog);
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.h	(revision 1004)
@@ -24,4 +24,5 @@
 	static LogManager *GetSingleton();
 
+	static void DelSingleton();
 
 protected:
